<?php
/*
Plugin Name: Trump Auth
Plugin URI: http://tech.inspiremedia.org/archives/358.html
Description: Creates an authentication image with trump image to help combat spam in comments.
Version: 1.0
Author: smalldust, charlee
Author URI: http://tech.inspiremedia.org/
*/

/*

This plugin is published under GPL.

The card images are original from http://waste.org/~oxymoron/cards/ .
I shrinked them to fit the size of authentication image.

The idea of trump-auth was from my friend smalldust.
*/

$sess_key_name = "trumpauth";

// if not included, output the authentication image.
if (basename($_SERVER["PHP_SELF"]) == "trump-auth.php") {
	session_start();
	$f = $_GET["f"];
	if ($f == 'i') {
		wp_ta_outputauthimage();
	}
} else {
	$wp_ta_authimage = get_settings('siteurl') . '/wp-content/plugins/trump-auth/trump-auth.php?f=i';
}

/**
 * Authentication code check function.
 */
function wp_ta_checkcode($code) {

	global $sess_key_name, $_SESSION;

	if (strtoupper($_SESSION[$sess_key_name]) == strtoupper($code)) {
		return 1;
	} else {
		return 0;
	}
}

/**
 * Authentication image generate function.
 */
function wp_ta_outputauthimage() {

	global $sess_key_name, $_SESSION;

	$img_width = 300;
	$img_height = 150;
	$margin_x = 10;
	$margin_y = 5;

	$card_img_path = "cards";

	$card_num = 5;


	// Generate a random card sequence
	// and convert it to auth code
	$card_seq = array();
	$auth_code = "";
	for ($i = 0; $i < $card_num; $i++) {
		$card = rand(1,52);
		if (!in_array($card, $card_seq)) {
			array_push($card_seq, $card);
			$auth_char = $card % 13;
			if ($auth_char == 11) $auth_char = 'J';
			else if ($auth_char == 12) $auth_char = 'Q';
			else if ($auth_char == 0) $auth_char = 'K';
			else if ($auth_char == 1) $auth_char = 'A';
			$auth_code .= $auth_char;
		} else {
			$i--;
		}
	}

	// save auth code into session
	$_SESSION[$sess_key_name] = $auth_code;

	$im = imagecreatetruecolor($img_width, $img_height);
	$white = imagecolorallocate($im, 255, 255, 255);
	$black = imagecolorallocate($im, 0, 0, 0);
	imagefilledrectangle($im, 0, 0, $img_width-1, $img_height-1, $white);
	//imagestring($im, 1, 1, 1, $auth_code, $black);

	// load card image
	$space = ($img_width - 2 * $margin_x - 40 ) / $card_num;
	for ($i = 0; $i < $card_num; $i++) {
		$filename = $card_seq[$i];
		if (strlen($filename) < 2) $filename = '0'.$filename;
		$filename = "$card_img_path/$filename.gif";
		$img_card = imagecreatefromgif($filename);
		$trans = imagecolorallocate($img_card, 128, 0, 0);
		if ($img_card) {
			$rotation = rand(-30,30);
			$img_card_r = imagerotate($img_card, $rotation, $trans);
			$trans = imagecolorallocate($img_card_r, 128, 0, 0);
			imagecolortransparent($img_card_r, $trans);
			imagecopymerge($im, $img_card_r, $margin_x + $i * $space, $margin_y + rand(0,20), 0, 0, imagesx($img_card_r), imagesy($img_card_r), 100);
			imagedestroy($img_card);
			imagedestroy($img_card_r);
		}
	}

	header("Content-Type: image/gif");
	imagegif($im);

	imagedestroy($im);

}


?>
